C        PROGRAM READ75
C  
C       ===================================================
C       Purpose: This program computes the values of the
C       growth parameter when capillarity effects are 
C       present. The size of time intervals (and thus radm) 
C       are readjusted until a convergent solution is found. 
C       ===================================================
C
C       Copyright Pedro Rivera and H. K. D. H. Bhadeshia,
C       University of Cambridge, 2001
C

       IMPLICIT DOUBLE PRECISION (A-H),INTEGER (I,J,K,N,r,T,O)
       DOUBLE PRECISION rad,Lm,da,dt,sp,ome,rho,radm,ra,al(50)
       DOUBLE PRECISION alph,drho,dc,dcp,radi
       DOUBLE PRECISION c(1000000,2),prsp,ALTAR,ic(50,2)
       DOUBLE PRECISION tim,rhor,rhoprev,alphprev,spprev

       PI=3.141592653589793D0           
       OU1 = 1
       OPEN(UNIT = OU1,FILE='read75.d')

       radi=40.d0

       DO 5 jj=75,75								

       dc=1.0d3
       DO 7 i=1,50
         ic(i,1)=1.d3
7      CONTINUE

10     radi=radi/2.d0
       radm=radi

       j=0
       kkk=0
       T=1000000
       r=1
       N=101
       k=1
       rad=1.01D0
       rhor=10**(0.01d0*K)
       da=1.D0
       Lm=2.D0*radm-1.01D0
       dt=1.d0*0.25D0*((Lm-radm)/(N-r))**2.D0

       ome=0.01*(jj*1.d0) 
       CALL ZENER(OME,ALTAR) 


       DO 20 i=2,N 
         c(i,1)=ome
20     CONTINUE

       rho=rad

30      j=j+1

         c(N,2)=ome
         c(1,1)=ome/rho

         sp=da*(N-r)*(1.d0/(1.D0-c(1,1)))*(c(2,1)-c(1,1))/((Lm-rho))
         rho=rho+sp*dt
         IF (rho.GT.1000.d0) THEN
           GOTO 190
         ENDIF
         IF (J.EQ.1) THEN
           tim=dt
         ELSE
           tim=tim+dt
         ENDIF
         ra=rho
         alph=rho/sqrt(tim)
         drho=rho-rhop

32      CONTINUE

         DO 35 i=2,N-1
           c(i,2)=((N-i)/(Lm-rho))*(c(i+1,1)-c(i-1,1))*sp/2.d0+
&          da*((N-r)**2/(Lm-rho)**2)*(c(i-1,1)-2*c(i,1)+c(i+1,1))+
&          (da/(rho+(i-r)*(Lm-rho)/(N-r)))*((N-r)/(Lm-rho))*
&          (c(i+1,1)-c(i-1,1))

           c(i,2)=c(i,2)*dt+c(i,1)

35       CONTINUE

        IF ((rhoprev.LT.rhor).AND.(rho.GT.rhor)) THEN
          pralph=(rhor-rhoprev)*(alph-alphprev)/(rho-rhoprev)
&         +alphprev
          prsp=(rhor-rhoprev)*(sp-spprev)/(rho-rhoprev)
&         +spprev

          IF (K.LE.48) THEN
            ic(k,2)=prsp
            al(k)=pralph
          ELSE
            write(OU1,200)rhor,pralph,prsp
          ENDIF

          IF ((K.GE.48).AND.(dc.gt.0.2d0)) THEN
          dc=0.D0
          DO 37 ii=1,48 
            dcp=abs(DLOG(ic(ii,2))-DLOG(ic(ii,1)))
            IF (dcp.gt.dc) THEN
              dc=dcp
            ENDIF            
            ic(ii,1)=ic(ii,2)
37        CONTINUE 
          IF (dc.gt.0.2d0) THEN
            GOTO 10
          ELSE
          DO 38 ii=1,48
            WRITE(OU1,200)10**(0.01d0*ii),al(ii),ic(ii,1)
38        CONTINUE
          ENDIF
          ENDIF

          IF (((pralph.ge.ALTAR).OR.(ABS((ALTAR-pralph)/ALTAR).LT.
&            1.0d-2)).AND.(rho.gt.1.d2)) THEN
            GOTO 80
          ENDIF
          IF (rhor.ge.1.d2) THEN
            GOTO 80
          ENDIF


          K=K+1
          rhor=10**(0.01d0*k)
       ENDIF
       
       rhoprev=rho
       alphprev=alph
       spprev=sp


        DO 40 i=2,N-1
           IF (c(i,2).LE.0.D0) THEN
             c(i,1)=0.d0
           ENDIF
           IF (c(i,2).GT.ome) THEN
             c(i,1)=ome
           ENDIF
           c(i,1)=c(i,2)
40     CONTINUE   

       IF ((ABS(ome-c(N-1,1)).GT.1.D-15).OR.
&          (rho.GE.0.90D0*radm)) THEN
         Lm=rho+2.D0*(Lm-rho)
         radm=(Lm-rho)/2.D0+rho
         N=2*(N-r)+r    
         DO 50 i=2,N 
           IF(i.LE.((N-r)/2+r)) THEN
             c(i,2)=c(i,1)
           ELSE
             c(i,2)=ome
           ENDIF         
50       CONTINUE
         dt=0.25D0*((Lm-radm)/(N-r))**2.D0
       ENDIF

       DO 70 i=2,N
           c(i,1)=c(i,2)
70     CONTINUE  
      
       GOTO 30

80     write(ou1,200)1.d4,altar,0.d0

5      CONTINUE

190    CONTINUE           

200    FORMAT(1X,15D15.5)
999    STOP
       END

        SUBROUTINE ZENER(o,GP)
C
C       =========================================
C       Purpose: Compute zener's value
C       Input:   o   --- supersaturation
C       Output:  GP --- value of growth parameter
C       =========================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER(I,J)
        double precision gt
        PI = 3.141592654             

        R = 1.0d10

        GP=0.5
        GP1=0.0D0
10      X=GP/2.0D0
        X1=GP1/2.0D0
15      IF (X.LT.3.D0) THEN
          CALL ERROR(X,ER)
          CALL ERROR(X1,ER1)
          F=((GP**2.0D0)/2.0D0)*(1-SQRT(PI)*0.5D0*GP*DEXP
&           (X**2)*(1.0D0-ER))
          F1=((GP1**2.0D0)/2.0D0)*(1-SQRT(PI)*0.5D0*GP*DEXP
&           (X1**2)*(1.0D0-ER1))
        ELSE
          CALL AC(X,GT)
          CALL AC(X1,GT1)
          ER=DEXP(-X**2.D0)*GT/DSQRT(PI)
          ER1=DEXP(-X1**2.D0)*GT1/DSQRT(PI)
          F=((GP**2.0D0)/2.0D0)*(1-SQRT(PI)*0.5D0*GP*DEXP
&           (X**2)*ER)
          F1=((GP1**2.0D0)/2.0D0)*(1-SQRT(PI)*0.5D0*GP*DEXP
&           (X1**2)*ER1)
        ENDIF

        P1=O-F1/(1.0D0+((1.0D0/R)*(F1-1.0D0)))
        P=O-F/(1.0D0+((1.0D0/R)*(F-1.0D0)))
        IF (((P.GT.0.0D0).AND.(P1.GT.0.0D0)).OR.
&         ((P.LT.0.0D0).AND.(P1.LT.0.0D0))) THEN
          GP1=GP
          GP=2.d0*GP
          GOTO 10
        ELSE
          GP=GP1+0.5D0*(GP-GP1)
          IF (ABS((GP-GP1)/GP).LT.1.0D-7) THEN
            GOTO 20
          ELSE
            GOTO 10
          ENDIF
        ENDIF
        P1=O-F1
        P=O-F
20      CONTINUE
        RETURN
200	FORMAT(1X,4D15.5)
        END


        SUBROUTINE ERROR(X,ERR)
C
C       =========================================
C       Purpose: Compute error function erf(x)
C       Input:   x   --- Argument of erf(x)
C       Output:  ERR --- erf(x)
C       =========================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        EPS=1.0D-15
        PI=3.141592653589793D0
        X2=X*X
        IF (DABS(X).LT.3.5D0) THEN
           ER=1.0D0
           R=1.0D0
           DO 10 K=1,50
              R=R*X2/(K+0.5D0)
              ER=ER+R
              IF (DABS(R).LE.DABS(ER)*EPS) GO TO 15
10         CONTINUE
15         C0=2.0D0/DSQRT(PI)*X*DEXP(-X2)
           ERR=C0*ER
        ELSE
           ER=1.0D0
           R=1.0D0
           DO 20 K=1,12
              R=-R*(K-0.5D0)/X2
20            ER=ER+R
           C0=DEXP(-X2)/(DABS(X)*DSQRT(PI))
           ERR=1.0D0-C0*ER
           IF (X.LT.0.0) ERR=-ERR
        ENDIF
        RETURN
        END

        SUBROUTINE AC(Z,f)
C
C       =========================================
C       Purpose: Compute continued fraction A(x)
C       Input:   x   --- Argument of A(x)
C       Output:  VA --- A(x)
C       =========================================
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z),INTEGER (I)
        DOUBLE PRECISION A0,Am1,B0,Bm1,ca1,df,fp
        DOUBLE PRECISION A1,B1,ca2,A2,B2

        A0=0.D0
        Am1=1.D0
        B0=1.D0
        Bm1=0.D0
        b=Z
        ca1=1.D0
        i=1
        df=1.D0
        fp=1.D0

        A1=b*A0+ca1*Am1
        B1=b*B0+ca1*Bm1

 10     CONTINUE

        IF (ABS(df).GE.1.D-15) THEN
           i=i+1
           ca2=(i/2.d0)-(1.d0/2.d0)
           A2=b*A1+ca2*A0
           B2=b*B1+ca2*B0
           f=A2/B2
           A0=A1
           B0=B1
           A1=A2
           B1=B2
           df=fp-f
           fp=f
           GOTO 10
        ENDIF

        RETURN
        END
